package com.framsticks.framclipse.script.model;

import java.util.Collections;
import java.util.List;

import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamImplicit;

public class Type {

	public static final Type[] BUILT_IN = {
			createBuiltInType("void"), createBuiltInType("integer"),
			createBuiltInType("float")
	};

	@XStreamAsAttribute
	private String name, context;

	private String description;

	@XStreamImplicit(itemFieldName = "element")
	private List<Element> elements;

	public String getName() {
		return name;
	}

	public String getContext() {
		return context;
	}

	public String getDescription() {
		return description;
	}

	public List<Element> getElements() {
		return elements != null ? elements : Collections.<Element> emptyList();
	}

	@Override
	public String toString() {
		return name;
	}

	public Element getElement(String name) {
		for (Element e : getElements()) {
			if (e.getName().equals(name)) {
				return e;
			}
		}
		return null;
	}

	public static Type createBuiltInType(String name) {
		Type type = new Type();
		type.name = name;
		type.context = null;
		type.description = "built-in type";
		return type;
	}
}
